# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)

    The version of the OpenAPI document: 6.15.2142
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, conint
from vrt_lss_studio.models.calculation_info import CalculationInfo
from vrt_lss_studio.models.tracedata import Tracedata

class ExperimentCalculation(BaseModel):
    """
    Experiment calculation details.  # noqa: E501
    """
    progress: conint(strict=True, le=100, ge=0) = Field(..., description="Calculation progress as a percentage. The progress displays the current number of completed steps. ")
    info: CalculationInfo = Field(...)
    tracedata: Tracedata = Field(...)
    __properties = ["progress", "info", "tracedata"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ExperimentCalculation:
        """Create an instance of ExperimentCalculation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of info
        if self.info:
            _dict['info'] = self.info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tracedata
        if self.tracedata:
            _dict['tracedata'] = self.tracedata.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ExperimentCalculation:
        """Create an instance of ExperimentCalculation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ExperimentCalculation.parse_obj(obj)

        _obj = ExperimentCalculation.parse_obj({
            "progress": obj.get("progress") if obj.get("progress") is not None else 0,
            "info": CalculationInfo.from_dict(obj.get("info")) if obj.get("info") is not None else None,
            "tracedata": Tracedata.from_dict(obj.get("tracedata")) if obj.get("tracedata") is not None else None
        })
        return _obj


