# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)

    The version of the OpenAPI document: 6.15.2142
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field
from vrt_lss_studio.models.actualize_settings import ActualizeSettings
from vrt_lss_studio.models.plan_settings import PlanSettings
from vrt_lss_studio.models.replan_settings import ReplanSettings

class ExperimentSettings(BaseModel):
    """
    Experiment settings.  # noqa: E501
    """
    plan_settings: PlanSettings = Field(...)
    replan_settings: ReplanSettings = Field(...)
    actualize_settings: ActualizeSettings = Field(...)
    __properties = ["plan_settings", "replan_settings", "actualize_settings"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ExperimentSettings:
        """Create an instance of ExperimentSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of plan_settings
        if self.plan_settings:
            _dict['plan_settings'] = self.plan_settings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of replan_settings
        if self.replan_settings:
            _dict['replan_settings'] = self.replan_settings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of actualize_settings
        if self.actualize_settings:
            _dict['actualize_settings'] = self.actualize_settings.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ExperimentSettings:
        """Create an instance of ExperimentSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ExperimentSettings.parse_obj(obj)

        _obj = ExperimentSettings.parse_obj({
            "plan_settings": PlanSettings.from_dict(obj.get("plan_settings")) if obj.get("plan_settings") is not None else None,
            "replan_settings": ReplanSettings.from_dict(obj.get("replan_settings")) if obj.get("replan_settings") is not None else None,
            "actualize_settings": ActualizeSettings.from_dict(obj.get("actualize_settings")) if obj.get("actualize_settings") is not None else None
        })
        return _obj


