# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)

    The version of the OpenAPI document: 6.15.2142
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime

from pydantic import BaseModel, Field, constr

class PerformerFact(BaseModel):
    """
    Fact.  # noqa: E501
    """
    key: constr(strict=True, max_length=1024, min_length=1) = Field(..., description="Fact key.")
    time: datetime = Field(..., description="Fact time in the [ISO 8601](https://tools.ietf.org/html/rfc3339#section-5.6) format.")
    performer_key: constr(strict=True, max_length=1024, min_length=1) = Field(..., description="Performer's key.")
    location_key: constr(strict=True, max_length=1024, min_length=1) = Field(..., description="Location key, unique identifier.")
    __properties = ["key", "time", "performer_key", "location_key"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PerformerFact:
        """Create an instance of PerformerFact from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PerformerFact:
        """Create an instance of PerformerFact from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PerformerFact.parse_obj(obj)

        _obj = PerformerFact.parse_obj({
            "key": obj.get("key"),
            "time": obj.get("time"),
            "performer_key": obj.get("performer_key"),
            "location_key": obj.get("location_key")
        })
        return _obj


