# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)

    The version of the OpenAPI document: 6.15.2142
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Union
from pydantic import BaseModel, Field, confloat, conint
from vrt_lss_studio.models.transport_type import TransportType

class TransportFactor(BaseModel):
    """
    Speed change coefficient for the specified transport type.  # noqa: E501
    """
    transport_type: TransportType = Field(...)
    speed: Union[confloat(le=1000, ge=0.1, strict=True), conint(le=1000, ge=1, strict=True)] = Field(..., description="Average transport speed multiplier.")
    __properties = ["transport_type", "speed"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TransportFactor:
        """Create an instance of TransportFactor from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TransportFactor:
        """Create an instance of TransportFactor from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TransportFactor.parse_obj(obj)

        _obj = TransportFactor.parse_obj({
            "transport_type": obj.get("transport_type"),
            "speed": obj.get("speed")
        })
        return _obj


