# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)

    The version of the OpenAPI document: 6.15.2142
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist
from vrt_lss_studio.models.hardlink import Hardlink
from vrt_lss_studio.models.linked_essence import LinkedEssence
from vrt_lss_studio.models.table_hardlink_fields import TableHardlinkFields

class WebHardlink(BaseModel):
    """
    Web Hardlink.  # noqa: E501
    """
    hardlink: Hardlink = Field(...)
    fields: Optional[TableHardlinkFields] = None
    linked_essences: Optional[conlist(LinkedEssence, max_items=15001, min_items=0)] = Field(None, description="A list of linked essences.")
    __properties = ["hardlink", "fields", "linked_essences"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> WebHardlink:
        """Create an instance of WebHardlink from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of hardlink
        if self.hardlink:
            _dict['hardlink'] = self.hardlink.to_dict()
        # override the default output from pydantic by calling `to_dict()` of fields
        if self.fields:
            _dict['fields'] = self.fields.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in linked_essences (list)
        _items = []
        if self.linked_essences:
            for _item in self.linked_essences:
                if _item:
                    _items.append(_item.to_dict())
            _dict['linked_essences'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> WebHardlink:
        """Create an instance of WebHardlink from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return WebHardlink.parse_obj(obj)

        _obj = WebHardlink.parse_obj({
            "hardlink": Hardlink.from_dict(obj.get("hardlink")) if obj.get("hardlink") is not None else None,
            "fields": TableHardlinkFields.from_dict(obj.get("fields")) if obj.get("fields") is not None else None,
            "linked_essences": [LinkedEssence.from_dict(_item) for _item in obj.get("linked_essences")] if obj.get("linked_essences") is not None else None
        })
        return _obj


