# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)

    The version of the OpenAPI document: 6.15.2142
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, conlist
from vrt_lss_studio.models.table_list_stats import TableListStats
from vrt_lss_studio.models.web_trip_chart import WebTripChart

class WebTripChartList(BaseModel):
    """
    Trips for chart.  # noqa: E501
    """
    charts: conlist(WebTripChart, max_items=15001, min_items=0) = Field(..., description="Data for chart.")
    statistics: TableListStats = Field(...)
    __properties = ["charts", "statistics"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> WebTripChartList:
        """Create an instance of WebTripChartList from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in charts (list)
        _items = []
        if self.charts:
            for _item in self.charts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['charts'] = _items
        # override the default output from pydantic by calling `to_dict()` of statistics
        if self.statistics:
            _dict['statistics'] = self.statistics.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> WebTripChartList:
        """Create an instance of WebTripChartList from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return WebTripChartList.parse_obj(obj)

        _obj = WebTripChartList.parse_obj({
            "charts": [WebTripChart.from_dict(_item) for _item in obj.get("charts")] if obj.get("charts") is not None else None,
            "statistics": TableListStats.from_dict(obj.get("statistics")) if obj.get("statistics") is not None else None
        })
        return _obj


